<?php

namespace Drush\Commands\dev_modules;

/**
 * Common code for Drush 9 and newer with Drupal 8.
 */
class DevModules8 extends DevModules {

  /**
   * {@inheritdoc}
   */
  protected function alterModuleLists() {
    $this->developmentModules += \Drupal::moduleHandler()->invokeAll('dev_modules_dev');
    $this->productionModules += \Drupal::moduleHandler()->invokeAll('dev_modules_production');
    \Drupal::moduleHandler()->alter('dev_modules_dev', $this->developmentModules);
    \Drupal::moduleHandler()->alter('dev_modules_production', $this->productionModules);
    return $this;
  }

  /**
   * {@inheritdoc}
   */
  protected function moduleExists($module) {
    return \Drupal::moduleHandler()->moduleExists($module);
  }

  /**
   * {@inheritdoc}
   */
  protected function enableModules() {
    \Drupal::service('module_installer')->install($this->enableModules, TRUE);
    return $this;
  }

  /**
   * {@inheritdoc}
   */
  protected function disableModules() {
    \Drupal::service('module_installer')->uninstall($this->disableModules);
    return $this;
  }

}
